/*
---
description: tooltip-like bubble to show images, inline content or ajax content

license: MIT-style

author:
- Johannes Fischer

requires:
- core/1.4: *
- more/1.4: Assets
- more/1.4: Fx.Elements

provides:
- BubbleBubble

...
*/

var BubbleBubble=new Class({Implements:Options,activeEl:null,bubble:null,delay:null,elements:null,linkType:null,position:null,tipHeight:11,visible:false,options:{animate:true,closeButton:false,contentClass:null,contentMargin:10,contentSource:"href",fxDuration:250,hideDelay:2500,margin:10,offset:20,position:"top",size:{height:200,width:250},stopOnclick:true,showOnclick:false,hideOnClick:true},initialize:function(a,b){this.setOptions(b);this.selector=a;if($$(a).length>0){this.attach();this.createBubble()}},attach:function(){if(this.options.stopOnclick){document.body.addEvent("click:relay("+this.selector+")",function(a,b){a.preventDefault()})}document.body.addEvent("mouseleave:relay("+this.selector+")",function(a,b){this.hideBubble()}.bind(this));document.body.addEvent("mouseover:relay("+this.selector+")",function(a,b){this.setLinkType(b);this.showBubble(b)}.bind(this))},calculatePosition:function(a,c,b){var d={};if(b===undefined||b===null){b=this.bubble.getSize()}if(a.test("bottom|top")){d.left=(c.left+(c.width/2)-(b.x/2)).round()}else{if(a.test("left|right")){d.top=(c.top+(c.height/2)-(b.y/2)).round()}}if(a==="bottom"){d.top=c.bottom+this.options.margin+this.tipHeight}else{if(a==="left"){d.left=c.left-b.x-this.options.margin-this.tipHeight}else{if(a==="right"){d.left=c.right+this.options.margin+this.tipHeight}else{if(a==="top"){d.top=c.top-b.y-this.options.margin-this.tipHeight}}}}return d},clearDelay:function(){window.clearInterval(this.delay)},createBubble:function(){this.bubbleContainer=new Element("div.BubbleBubble",{styles:{height:this.options.size.height+this.tipHeight+(this.options.contentMargin*2),opacity:0,width:this.options.size.width+(this.options.contentMargin*2)}}).inject(document.body);this.bubble=new Element("div.BubbleBubble-Bubble",{events:{mouseleave:function(){this.hideBubble()}.bind(this),mouseover:function(){this.clearDelay()}.bind(this)},styles:{height:this.options.size.height+(this.options.contentMargin*2)}}).inject(this.bubbleContainer);if(this.options.closeButton){new Element("span.BubbleBubble-close",{events:{click:function(){this.hideBubble(false)}.bind(this)},html:"&times;"}).inject(this.bubble)}if(this.options.animate){this.bubbleContainer.store("fxInstance",new Fx.Morph(this.bubbleContainer,{duration:this.options.fxDuration}))}this.bubbleContent=new Element("div.BubbleBubble-Content",{styles:{height:this.options.size.height}}).inject(this.bubble);if(this.options.contentClass){this.bubbleContent.addClass(this.options.contentClass)}},getContent:function(a){var d,c,b;this.bubbleContent.addClass("BubbleBubble-loading");b=a.get(this.options.contentSource);if(b===null){return}if(this.linkType==="inline"){this.resetBubble();d=b.substr(b.indexOf("#")+1);if(document.id(d)){this.setContent(document.id(d).get("html"))}}else{if(this.linkType==="image"){c=a.retrieve("image");if(!c){c=new Asset.image(a.get(this.options.contentSource),{onload:function(){this.insertImage(a,c);a.store("image",c)}.bind(this)})}else{this.insertImage(a,c)}}else{this.resetBubble(true);if(a.retrieve("responseHTML")){this.setContent(a.retrieve("responseHTML"))}else{new Request.HTML({onSuccess:function(f,e,g){a.store("responseHTML",g);this.bubbleContent.removeClass("BubbleBubble-loading")}.bind(this),update:this.bubbleContent,url:b}).send()}}}},getOffsetStyles:function(){return{offset:this.position.test("left|top")?this.options.offset*-1:this.options.offset,position:this.position.test("left|right")?"left":"top"}},hideBubble:function(a){var c,b;b={opacity:0};c=this.getOffsetStyles();b["margin-"+c.position]=c.offset;this.delay=(function(){if(this.options.animate===true){this.bubbleContainer.retrieve("fxInstance").start(b).chain(function(){this.reset()}.bind(this))}else{this.bubbleContainer.fade("hide");this.reset()}}.bind(this)).delay(a===undefined||a===true?this.options.hideDelay:0)},insertImage:function(c,e){var f=false,b=false,a=c.retrieve("image"),d;e.setStyle("opacity",0);this.bubbleContent.empty().adopt(e);d=e.getSize();if(!a){f=true}this.resizeBubble(c,d.y,d.x,f)},reset:function(){this.activeEl=null;this.resetBubble();this.bubbleContainer.setStyle("display","none");this.visible=false},resetBubble:function(){this.bubbleContainer.setStyles({height:this.options.size.height+this.tipHeight+(this.options.contentMargin*2),width:this.options.size.width+(this.options.contentMargin*2)});this.bubble.setStyle("height",this.options.size.height+(this.options.contentMargin*2));this.bubbleContent.setStyle("height",this.options.size.height).empty().addClass("BubbleBubble-loading")},resizeBubble:function(b,k,a,f){var e,j,d,i,c,g,h;e=this.bubble.getSize();j=b.getCoordinates();if(k===e.y&&a===e.x){if(f!==undefined&&f===true){this.bubbleContent.getFirst().fade(1)}else{this.bubbleContent.getFirst().setStyle("opacity",1)}return}c={x:a+(this.options.contentMargin*2),y:k+(this.options.contentMargin*2)};i=this.calculatePosition(this.options.position,j,c);new Fx.Elements($$(this.bubbleContainer,this.bubble,this.bubbleContent),{duration:this.options.fxDuration,onComplete:function(){this.bubble.setStyle("height",k+(this.options.contentMargin*2));this.bubbleContent.setStyle("height",k).removeClass("BubbleBubble-loading");if(f!==undefined&&f===true){this.bubbleContent.getFirst().fade(1)}else{this.bubbleContent.getFirst().setStyle("opacity",1)}}.bind(this)}).start({"0":{height:k+this.tipHeight+(this.options.contentMargin*2),left:i.left,top:i.top,width:a+(this.options.contentMargin*2)},"1":{height:k+(this.options.contentMargin*2)},"2":{height:k}})},setBubbleContent:function(a){this.bubbleContent.removeClass("BubbleBubble-loading").adopt(a)},setContent:function(a){this.resetBubble();this.bubbleContent.removeClass("BubbleBubble-loading").set("html",a)},setLinkType:function(a){var b=a.get(this.options.contentSource);if(b.indexOf("#")>-1){this.linkType="inline"}else{if(b.test(".gif|.jpeg|.jpg|.png")){this.linkType="image"}else{this.linkType="ajax"}}},setPosition:function(b){var a=this.options.position;["bottom","left","right","top"].each(function(c){if(b.hasClass("bubble-"+c)){a=c}if(this.bubbleContainer.hasClass("BubbleBubble-"+c)){this.bubbleContainer.removeClass("BubbleBubble-"+c)}},this);this.bubbleContainer.addClass("BubbleBubble-"+a);return a},showBubble:function(b){var d,f,e,g,a,c;this.position=this.setPosition(b);this.bubbleContainer.setStyles({display:"block",margin:0});this.clearDelay();if(this.activeEl===b){return}this.activeEl=b;f=b.getCoordinates();a=null;if(this.visible&&this.linkType==="image"){a=this.bubbleContent.getSize()}g=this.calculatePosition(this.position,f,a);this.bubbleContainer.setStyles({left:g.left,top:g.top});this.getContent(b);if(this.visible){return}if(this.options.animate){c={opacity:[0,1]};e=this.getOffsetStyles();c["margin-"+e.position]=[e.offset,0];this.bubbleContainer.retrieve("fxInstance").start(c);this.visible=true}else{this.bubbleContainer.fade("show")}}});